<?php
namespace Modules\Cotacao\Modules\Pedido\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class ControlePedidoColetaRelatorios extends \Zeedhi\Framework\Controller\Report {
    protected $reportService;
    protected $birtStrategy;
    protected $environment;
    protected $qr2Strategy;
    protected $connection;
    protected $repParam;
    
    
    public function __construct($reportService, $birtStrategy, $environment, $qr2Strategy, $connection) {
        $this->reportService     = $reportService;
        $this->birtStrategy      = $birtStrategy;
        $this->environment       = $environment;
        $this->qr2Strategy       = $qr2Strategy;
        $this->connection        = $connection;
        $this->repParam = array ();
    }
    
    protected $reportMapping = array ();
        
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {   
        $row = $request->getRow();
        $row['P_CDPRODFIN'] = str_pad($row['P_CDPRODFIN'], 10, 'Z');
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
            array(
                'strategy' => isset($row['STRATEGY']) ? $row['STRATEGY'] : 'QR2',
                'parameterMapping' => 
                array (
                    "P_CDFILIAL"        => "P_CDFILIAL",
                    "L_CDOPERADOR"      => "L_CDOPERADOR",
                    "L_CDREGIAO"        => "L_CDREGIAO",
                    "L_CDFORNECED"      => "L_CDFORNECED",
                    "P_DTINI"           => "P_DTINI",
                    "P_DTFIN"           => "P_DTFIN",
                    "P_CDPRODINI"       => "P_CDPRODINI",
                    "P_CDPRODFIN"       => "P_CDPRODFIN",
                    "P_TEXTPRODFIN"     => "P_TEXTPRODFIN",
                    "P_TCDPRODUTO"      => "P_TCDPRODUTO",
                    "P_TPROD"           => "P_TPROD",
                    "L_SITUACAO"        => "L_SITUACAO"
                )
            );

        // $this->reportMapping = array ()
        //     'LIB03700' => $this->repParam,
        //     'LIB03701' => $this->repParam,
        //     'LIB03702' => $this->repParam,
        //     'LIB03703' => $this->repParam,
        //     'LIB03711' => $this->repParam,
        //     'LIB03712' => $this->repParam
        // );
    }

    // public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    //     $row = $request->getRow();
    //     $row['P_CDPRODFIN'] = str_pad($row['P_CDPRODFIN'], 10, 'Z');
    //     $qr2type = isset($row['QR2TYPE']) ? $row['QR2TYPE'] : 'PDF';
    //     $this->QR2Strategy->setQr2Type($qr2type);
    // }
    
    
}