<?php
namespace Modules\Cotacao\Modules\Pedido\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Modules\Cotacao\Modules\Pedido\Services\Sup09600IImportacaodeRFPService;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Request\Row;

class Sup09600IImportacaodeRFPController extends \Zeedhi\Framework\Controller\Report
{

    protected $newCode;
    protected $environment;
    
    protected $errors = array();
    protected $errorMessages = array();
    
    public function __construct($newCode, $environment, Sup09600IImportacaodeRFPService $service)
    {
        $this->newCode       = $newCode;
        $this->environment   = $environment;
        $this->service       = $service;
    }

    public function importarXlsRFB(DTO\Request $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            $answer = $this->service->readXlsHeader($row, $response);
            if($answer['MESSAGE'] == 'SUCCESS_OPERATION'){
            $tableExists = $this->service->readXls($row);
                if($tableExists['MESSAGE'] == 'SUCCESS_OPERATION'){
                    $response->addMessage(new Message($tableExists));
                }else $response->addMessage(new Message($tableExists));
            }//
            else $response->addMessage(new Message($answer));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 1));
        } 
    }
    
    public function deleteImport(DTO\Request $request, DTO\Response $response){
        $conditions = $request->getRow();
        $params = array(
                    "NRRFPMAIN"   => $conditions["NRRFPMAIN"]
                    );
        $delete = $this->service->searchSTATUSDelete($params);
        try{
            if($delete !== 'GERADO'){
            $nr = $params["NRRFPMAIN"];
            $this->service->deleteRFPITEMCOTA($nr);
            $this->service->deleteRFPFORNECEDOR($nr);
            $this->service->deleteRFPREGIAO($nr);
            $this->service->deleteRFPPRODMARCA($nr);
            $this->service->deleteRFMAIN($nr);
            $result = ['MESSAGE' => 'EXCLUIDO_SUCESSO'];
            $response->addMessage(new Message($result));
        }
            else if ($delete == 'GERADO'){
            $result = ['MESSAGE' => 'IMPOSSIVEL_EXCLUIR_GERADO'];
            $response->addMessage(new Message($result));
        }
        }catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 1));
        }
    }
    public function gerarPedido(DTO\Request $request, DTO\Response $response){
        $conditions = $request->getRow();
        $cdop = explode(" -",$conditions["CDOPERINCL"]);
        $params = array(
                    "NRRFPMAIN" => $conditions["NRRFPMAIN"],
                    "CDOPERINCL" => $cdop[0],
                    "IDDISMONTLIS" => $conditions["IDDISMONTLIS"]
                    );
        try{
           $result = $this->service->callProcedureIMPORTA_RFP($params);
           $response->addMessage(new Message($result));
        }catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 1));
        }
    }

    
}