<?php
namespace Modules\Fornecimento\Modules\AutorizacaoFornecimento\Services;

class AprovacaoAlcadasService
{
    public function __construct($connection)
    {
        $this->connection = $connection;
    }
    
    public function getAlcadas($conditions)
    {
        $sql = "SELECT A.NRAPROVALCADA,
                  A.NRCONFIGALCADA,
                  C.NMALCADA,
                  C.IDTIPOVRAPROV,
                  A.CDFILDEST,
                  DEST.NMFILIAL NMFILDEST,
                  A.CDFILLANC,
                  A.NRDEMANDA,
                  A.IDTPDEMANDA,
                  A.IDCLASSIFIC,
                  A.IDAPROVADO,
                  F.VRTOTALAF,
                  AL.CDOPERADOR APROVADOR,
                  AL.VRAPROVCMP,
                  TO_CHAR(A.DTINCLUSAO, 'DD/MM/YYYY') AS DTINCLUSAO,
                  F.DSMOTVAFALCADA,
                  A.NRORG,
                  MIN(DTPROGENTAF) DTPROGENTAF,
                  FORN.NRINSJURFORN,
                  FORN.NMRAZSOCFORN,
                  FORN.NMFANTFORN
                FROM APROVALCADA A,
                  FILIAL DEST,
                  CONFIGALCADA C,
                  AUTOFORNE F,
                  ALCADAGERFILI AL,
                  ITEMAUTF,
                  FORNECEDOR FORN
                WHERE ((INSTR(:CDFILIAL, A.CDFILDEST)          > 0)
                OR (:CDFILIAL                                  = 'T'))
                AND ((INSTR(:IDCLASSIFIC, A.IDCLASSIFIC)       > 0)
                OR (:IDCLASSIFIC                               = 'T'))
                AND ((INSTR(:IDAPROVADO, A.IDAPROVADO)         > 0)
                OR (:IDAPROVADO                                = 'T'))
                AND ((INSTR(:NRCONFIGALCADA, C.NRCONFIGALCADA) > 0)
                OR (:NRCONFIGALCADA                            = 'T'))
                AND A.CDOPERADOR                               = :CDOPERADOR
                AND A.CDFILDEST                                = DEST.CDFILIAL
                AND A.NRCONFIGALCADA                           = C.NRCONFIGALCADA
                AND A.CDFILDEST                                = F.CDFILDEST
                AND A.CDFILLANC                                = F.CDFILLANC
                AND A.NRDEMANDA                                = F.NRAUTOFORN
                AND A.NRCONFIGALCADA                           = AL.NRCONFIGALCADA
                AND A.CDFILDEST                                = AL.CDFILIAL
                AND A.CDOPERADOR                               = AL.CDOPERADOR
                AND F.CDFILDEST = ITEMAUTF.CDFILDEST 
                AND ( F.CDFILLANC = ITEMAUTF.CDFILLANC )
                AND ( F.NRAUTOFORN = ITEMAUTF.NRAUTOFORN )
                AND F.CDFORNECED = FORN.CDFORNECED
                AND ( A.DTINCLUSAO BETWEEN :P_DTINCLUSAO_INI AND :P_DTINCLUSAO_FIN
                                  OR :P_TDTINCLUSAO = 'T' )
                GROUP BY 
                A.NRAPROVALCADA,
                  A.NRCONFIGALCADA,
                  C.NMALCADA,
                  A.CDFILDEST,
                  DEST.NMFILIAL,
                  A.CDFILLANC,
                  A.NRDEMANDA,
                  A.IDTPDEMANDA,
                  A.IDCLASSIFIC,
                  A.IDAPROVADO,
                  F.VRTOTALAF,
                  AL.CDOPERADOR,
                  AL.VRAPROVCMP,
                  TO_CHAR(A.DTINCLUSAO, 'DD/MM/YYYY'),
                  F.DSMOTVAFALCADA,
                  A.NRORG,
                  FORN.NRINSJURFORN,
                  FORN.NMRAZSOCFORN,
                  FORN.NMFANTFORN,
                  C.IDTIPOVRAPROV
                HAVING ((MIN(DTPROGENTAF)  BETWEEN :P_DTENTREGAAF_INI AND :P_DTENTREGAAF_FIN)
                OR (:P_TDTENTREGAAF = 'T'))";
        try {
            $std = $this->connection->prepare($sql);
            $std->execute(
                array (
                    'CDFILIAL'          => $conditions['CDFILIAL'],
                    'CDOPERADOR'        => $conditions['CDOPERADOR'],
                    'IDAPROVADO'        => $conditions['IDAPROVADO'],
                    'IDCLASSIFIC'       => $conditions['IDCLASSIFIC'],
                    'NRCONFIGALCADA'    => $conditions['NRCONFIGALCADA'],
                    'P_DTINCLUSAO_INI'  => $conditions['P_DTINCLUSAO_INI'],
                    'P_DTINCLUSAO_FIN'  => $conditions['P_DTINCLUSAO_FIN'],
                    'P_TDTINCLUSAO'     => $conditions['P_TDTINCLUSAO'],
                    'P_DTENTREGAAF_INI' => $conditions['P_DTENTREGAAF_INI'],
                    'P_DTENTREGAAF_FIN' => $conditions['P_DTENTREGAAF_FIN'],
                    'P_TDTENTREGAAF'    => $conditions['P_TDTENTREGAAF'],
                )
            );
            
            return $std->fetchAll();
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function defineColumn($IDAPROVADO)
    {
        if ($IDAPROVADO == 'PENDENTE')
            return 1;
        else if ($IDAPROVADO == 'APROVADO')
            return 2;
        else if ($IDAPROVADO == 'RECUSADO')
            return 3;
    }
    
    public function getNameClassific($IDCLASSIFIC)
    {
        if ($IDCLASSIFIC == 'FORA_ORCAMENTO')
            return 'Fora do Orçamento';
        else if ($IDCLASSIFIC == 'PADRAO')
            return 'Padrão';
        else if ($IDCLASSIFIC == 'EXTRA')
            return 'Extra';
        else
            return $IDCLASSIFIC;
    }
    
    public function getNameIdAprovado($IDAPROVADO)
    {
        if ($IDAPROVADO == 'PENDENTE')
            return 'Pendente';
        else if ($IDAPROVADO == 'APROVADO')
            return 'Aprovado';
        else if ($IDAPROVADO == 'RECUSADO')
            return 'Reprovado';
        else
            return $IDCLASSIFIC;
    }
}
