<?php
/**
 * Created by PhpStorm.
 * User: carinaoliveira
 * Date: 07/01/2015
 * Time: 09:28
 */

namespace Fiscal\Logic\NotaFiscal;

use Fiscal\Logic\NotaFiscal\Exceptions\AprovacaoException;
use Geral\Entities\Tipooperac;
use Contabilidade\Entities\Contopectbl;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class ValidaDataIntegracao {

    public static function validaDataIntegracao($cdempresa, $identrsaiop, $cdtipooperac, $dtreferencia){
        $nrorg = Ambiente::getNrorg();

        $tipooperac = Tipooperac::findOneByIdentrsaidopAndCdtipooperAndNrorg($identrsaiop, $cdtipooperac, $nrorg);
        $idcontaboper = $tipooperac->getIdcontaboper();

        $contopectbl = Contopectbl::findOneByCdempresaAndNrorg($cdempresa, $nrorg);
        $dtiniintcontdfe = $contopectbl->getDtiniintcontdfe();
        $dtfinintcontdfe = $contopectbl->getDtfinintcontdfe();
        $dtiniintcontdfs = $contopectbl->getDtiniintcontdfs();
        $dtfinintcontdfs = $contopectbl->getDtfinintcontdfs();


        if ($dtiniintcontdfe && $dtiniintcontdfs) {

            if($idcontaboper == 'S') {

                if($identrsaiop == 'E') {
                    if ( !(((DateUtil::comparaDatas($dtiniintcontdfe, $dtreferencia, DateUtil::ANTES)) || (DateUtil::comparaDatas($dtiniintcontdfe, $dtreferencia, DateUtil::IGUAL))) &&
                         ((DateUtil::comparaDatas($dtfinintcontdfe, $dtreferencia, DateUtil::DEPOIS)) || (DateUtil::comparaDatas($dtfinintcontdfe, $dtreferencia, DateUtil::IGUAL))))
                       ) {
                        AprovacaoException::dataRefForaPerIntegEntrada();
                    }
                }
                else {
                    if ( !(((DateUtil::comparaDatas($dtiniintcontdfs, $dtreferencia, DateUtil::ANTES)) || (DateUtil::comparaDatas($dtiniintcontdfs, $dtreferencia, DateUtil::IGUAL))) &&
                        ((DateUtil::comparaDatas($dtfinintcontdfs, $dtreferencia, DateUtil::DEPOIS)) || (DateUtil::comparaDatas($dtfinintcontdfs, $dtreferencia, DateUtil::IGUAL))))
                    ) {
                        AprovacaoException::dataRefForaPerIntegSaida();
                    }
                }

            }

        }

    }

} 