<?php
namespace Planejamento\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class Itembdistcard extends Base\Itembdistcard
{
    public static function Insere($nrembdistcard, $nrdistcard, $nrseqpratcar,
                                  $qtcomensais, $qtprato, $qtextra, $idcadauto, $connection, $docommit = true){
        try{
            if(!$connection){
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();
            }

            $nrorg = Ambiente::getNrorg();
            $cdoperador = Ambiente::getCdOperador();

            $it = new Itembdistcard();
            $it->setNrdistcard($nrdistcard);
            $it->setNrembdistcard($nrembdistcard);
            $it->setNrseqpratcar($nrseqpratcar);
            $it->setQtcomensais($qtcomensais);
            $it->setQtprato($qtprato);
            $it->setQtextra($qtextra);
            $it->setIdcadauto($idcadauto);

            //Auditoria
            $it->setNrorg($nrorg);
            $it->setNrorginclusao($nrorg);
            $it->setNrorgultatu($nrorg);

            $it->setCdoperinclusao($cdoperador);
            $it->setCdoperultatu($cdoperador);

            $it->setDtinclusao(DateUtil::getDataAtual());
            $it->setDtultatu(DateUtil::getDataAtual());

            $it->setIdativo('S');

            $it->persist();

            $connection->flush();
            if($docommit) $connection->commit();

        }catch(\Exception $e){
            if($docommit) $connection->rollback();
            throw $e;
        }

    }


    public static function ApagaTodosItemsEmbalagem($nrembdistcard, $connection, $docommit = true){
        try{
            if(!$connection){
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();
            }

            $nrorg = Ambiente::getNrorg();

            $items = Itembdistcard::getObjectsByWhere('NRORG = ? AND NREMBDISTCARD = ?',
                                                      array($nrorg, $nrembdistcard));

            if($items){
                foreach($items as $it){
                    $it->delete();
                }
            }

            $connection->flush();
            if($docommit) $connection->commit();
        }catch(\Exception $e){
            if($docommit) $connection->rollback();
            throw $e;
        }
    }

    public static function buscaEmbalagensDoPrato($nrdistcard, $nrseqpratcar, $nrorg){

        /**
         * @var \Planejamento\Entities\Itembdistcard $itens Itembdistcard
         */
        $itens = Itembdistcard::getObjectsByWhere('NRORG = ? AND NRDISTCARD = ? AND NRSEQPRATCAR = ?',
            array($nrorg, $nrdistcard, $nrseqpratcar));

        return $itens;
    }
}