/* Sistemas Integrados TEKNISA
  Integrao - SAGA

 Nome: Rotina de exportao das ordens de sada para o SAGA

Criao:
11/04/2013 - Fabrcio Marcelo

@C:\web_545\sql\end_conv\oracle\clientes\ris\6460_RISSTPO_Exporta_Ordem_Saida_Saga.SQL
*/

CREATE OR REPLACE PROCEDURE EXPORTA_ORDEM_SAIDA_SAGA
AS
   V_NRCONTADOR   INT;
   V_CHAVENF      VARCHAR2(15);
BEGIN
   V_NRCONTADOR := 0;

   V_CHAVENF := 'A';

   /* Novos registros */
   FOR C_NF IN (/* Pedidos Aprovados (sistema Pedidos) para produtos que comecam com o codigo igual a 1 */
                SELECT '' AS CDFORNECED, '' AS CDCLIENTE, N.CDFILIALPED AS CDFILIMOVI,
                       N.IDENTRSAIDOP, P.CDFILIALSAGA, '2'||N.CDFILIAL||N.NRPEDIDO AS NROORD,
                       N.CDFILIAL, N.NRPEDIDO AS NRLANCTONF, F.CDFILIAL AS NRINSJURNF,
                       2||TO_NUMBER(SUBSTR(N.CDFILIAL,1,2))||TO_NUMBER(N.NRPEDIDO) AS IDCSEQ, 5 AS CODTIPORD,
                       TO_NUMBER(I.NRITEMPED) AS NRSEQITPROD, E.CDARVPROD,
                       (I.QTITEMPED / NVL(C.VRFATORSKU,1)) AS QTITEMPROD, NVL(E.VRFATOCONV,1) AS VRFATOCONV,
                       I.NRITEMPED, TO_DATE(N.DTENTPED) AS DTMOVI
                  FROM PARAMFILIAL P, PEDIDO N,
                       ITEMPEDIDO I, PRODUTO P, PRODUTO E, PRODFILI PF, FILIAL F,
                       CARACPRODSAGA C
                 WHERE NOT P.CDFILIALSAGA IS NULL
                   AND P.CDFILIAL = N.CDFILIAL
                   AND ((N.IDSITPEDIDO  = '2') OR (N.IDSITPEDIDO = '6'))
                   AND N.DTEXPPEDSAGA IS NULL
                   AND I.CDFILIAL = N.CDFILIAL
                   AND I.NRPEDIDO = N.NRPEDIDO
                   AND I.IDSITITEMPED = '3'
                   AND I.DTEXPITPEDSAGA IS NULL
                   AND I.CDPRODUTO = P.CDPRODUTO
                   AND E.CDPRODUTO = P.CDPRODESTO
                   AND PF.CDFILIAL = N.CDFILIAL
                   AND PF.CDPRODUTO = P.CDPRODESTO
                   AND NVL(IDCNTRESTOQ, 'S') <> 'N'
                   AND F.CDFILIAL = N.CDFILIALPED
                   AND C.CDPRODUTO = P.CDPRODUTO
                 ORDER BY IDENTRSAIDOP, CDFILIAL, NRLANCTONF, NRSEQITPROD)
   LOOP
      IF V_CHAVENF <> C_NF.NROORD THEN

         FOR C_PS IN (SELECT F.IDTPIJURFORN AS IDT, F.CDFORNECED AS CHAVE, 'F' AS ID, F.NRINSJURFORN AS NRINSJUR, F.NMRAZSOCFORN AS NMRAZAOSOC, F.NMFANTFORN AS NMFANTASIA, E.NRCEPFORN AS CEP,
                             P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRFORN AS NMBAIRRO,
                             E.DSENDEFORN AS DSENDERECO, 10 AS CODNATPSS
                        FROM FORNECEDOR F, ENDEFORN E, PAIS P, ESTADO ES, MUNICIPIO M
                       WHERE F.CDFORNECED = C_NF.CDFORNECED
                         AND E.CDFORNECED = F.CDFORNECED
                         AND E.IDTPENDEFORN = 'P'
                         AND P.CDPAIS = E.CDPAIS
                         AND ES.CDPAIS = E.CDPAIS
                         AND ES.SGESTADO = E.SGESTADO
                         AND M.CDPAIS = E.CDPAIS
                         AND M.SGESTADO = E.SGESTADO
                         AND M.CDMUNICIPIO = E.CDMUNICIPIO

                       UNION ALL

                      SELECT F.IDTPIJURCLIE AS IDT, F.CDCLIENTE AS CHAVE, 'C' AS ID, F.NRINSJURCLIE AS NRINSJUR, F.NMRAZSOCCLIE AS NMRAZAOSOC, F.NMFANTCLIE AS NMFANTASIA, E.NRCEPCLIE AS CEP,
                             P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRCLIE AS NMBAIRRO,
                             E.DSENDECLIE AS DSENDERECO, 9 AS CODNATPSS
                        FROM CLIENTE F, ENDECLIE E, PAIS P, ESTADO ES, MUNICIPIO M
                       WHERE F.CDCLIENTE = C_NF.CDCLIENTE
                         AND E.CDCLIENTE = F.CDCLIENTE
                         AND E.IDTPENDECLIE = 'P'
                         AND P.CDPAIS = E.CDPAIS
                         AND ES.CDPAIS = E.CDPAIS
                         AND ES.SGESTADO = E.SGESTADO
                         AND M.CDPAIS = E.CDPAIS
                         AND M.SGESTADO = E.SGESTADO
                         AND M.CDMUNICIPIO = E.CDMUNICIPIO

                       UNION ALL

                      SELECT 'J' AS IDT, F.CDFILIAL AS CHAVE, 'L' AS ID, F.CDFILIAL AS NRINSJUR, F.NMFILIAL AS NMRAZAOSOC, F.NMFILIAL AS NMFANTASIA, E.NRCEPFILI AS CEP,
                             P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRFILI AS NMBAIRRO,
                             E.DSENDEFILI AS DSENDERECO, 9 AS CODNATPSS
                        FROM FILIAL F, ENDEFILI E, PAIS P, ESTADO ES, MUNICIPIO M
                       WHERE F.CDFILIAL = C_NF.CDFILIMOVI
                         AND E.CDFILIAL = F.CDFILIAL
                         AND E.IDTPENDEFILI = 'P'
                         AND P.CDPAIS = E.CDPAIS
                         AND ES.CDPAIS = E.CDPAIS
                         AND ES.SGESTADO = E.SGESTADO
                         AND M.CDPAIS = E.CDPAIS
                         AND M.SGESTADO = E.SGESTADO
                         AND M.CDMUNICIPIO = E.CDMUNICIPIO

                       UNION ALL

                      SELECT 'J' AS IDT, F.CDFILIAL AS CHAVE, 'L' AS ID, F.CDFILIAL AS NRINSJUR, F.NMFILIAL AS NMRAZAOSOC, F.NMFILIAL AS NMFANTASIA, E.NRCEPFILI AS CEP,
                             P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRFILI AS NMBAIRRO,
                             E.DSENDEFILI AS DSENDERECO, 12 AS CODNATPSS
                        FROM FILIAL F, ENDEFILI E, PAIS P, ESTADO ES, MUNICIPIO M
                       WHERE F.CDFILIAL = C_NF.CDFILIMOVI
                         AND E.CDFILIAL = F.CDFILIAL
                         AND E.IDTPENDEFILI = 'P'
                         AND P.CDPAIS = E.CDPAIS
                         AND ES.CDPAIS = E.CDPAIS
                         AND ES.SGESTADO = E.SGESTADO
                         AND M.CDPAIS = E.CDPAIS
                         AND M.SGESTADO = E.SGESTADO
                         AND M.CDMUNICIPIO = E.CDMUNICIPIO)
         LOOP
            IF C_PS.IDT = 'J' THEN
               INSERT INTO INT_CADPSJ
                  (CODPSS, NOMPSS, NOMAPEPSS, CODSITPSJ, DATCAD, DATHORBLQ,
                   CODMTV, NOMEML, NOMWEBSIT, NUMCEL1, NUMCEL2, NUMFAX,
                   NUMIDPSSPRM, NUMIDPSSSCG, NUMTEL1, NUMTEL2, CODNATPSS, CODPPSEXT,
                   BOLPDRCRP, CEP, CODTIPENDPTL, NOMPAI, NOMUFE, NOMLOC,
                   NOMBRO, NOMRUA, NUMCMP, NOMCMP, FLAPRC, DSCERR, DATULTPRC)
               VALUES
                  (C_PS.NRINSJUR, C_PS.NMRAZAOSOC, C_PS.NMFANTASIA, 1, SYSDATE, NULL,
                   NULL, NULL, NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, NULL, C_PS.CODNATPSS, NULL,
                   1, C_PS.CEP, 1, C_PS.NMPAIS, C_PS.NMESTADO, C_PS.NMMUNICIPIO,
                   C_PS.NMBAIRRO, C_PS.DSENDERECO, NULL, NULL, '0', NULL, NULL);

               V_NRCONTADOR := V_NRCONTADOR + 1;
            ELSE
               INSERT INTO INT_CADPSF
                  (CODPSS, NOMPSS, NOMAPEPSS, CODSITPSF, CODTIPCRTMTR, DATADM, DATDEM,
                   NUMCRATRB, NUMINSS, NUMPIS, NUMTITELE, CODNATPSS, CODPPSEXT, BOLPDRCRP,
                   CEP, CODTIPENDPTL, NOMPAI, NOMUFE, NOMLOC, NOMBRO, NOMRUA, NUMCMP,
                   NOMCMP, DATCAD, FLAPRC, DSCERR, DATULTPRC, NUMIDPSSPRM, NUMIDPSSSCG)
               VALUES
                  (C_PS.NRINSJUR, C_PS.NMRAZAOSOC, C_PS.NMFANTASIA, 1, NULL, NULL, NULL,
                   NULL, NULL, NULL, NULL, 16, NULL, 1,
                   C_PS.CEP, 1, C_PS.NMPAIS, C_PS.NMESTADO, C_PS.NMMUNICIPIO, C_PS.NMBAIRRO, C_PS.DSENDERECO, NULL,
                   NULL, SYSDATE, '0', NULL, NULL, NULL, NULL);
            END IF;

            UPDATE FORNECEDOR
               SET DTEXPFORNSAGA = SYSDATE
             WHERE CDFORNECED = C_NF.CDFORNECED;

            UPDATE CLIENTE
               SET DTEXPCLIESAGA = SYSDATE
             WHERE CDCLIENTE = C_NF.CDCLIENTE;

            UPDATE FILIAL
               SET DTEXPFILISAGA = SYSDATE
             WHERE CDFILIAL = C_NF.CDFILIMOVI;

            /* Relacionamento da pessoa juridica com a filial */
            FOR C_FILIAL IN (SELECT DISTINCT CDFILIALSAGA FROM PARAMFILIAL
                              WHERE NOT CDFILIALSAGA IS NULL)
            LOOP
               INSERT INTO INT_CADACSPSS
                  (CODSTE, CODTRN, CODPSS, FLAPRC, DSCERR, DATULTPRC)
               VALUES
                  (C_FILIAL.CDFILIALSAGA, 0, C_PS.NRINSJUR, '0', NULL, NULL);

               V_NRCONTADOR := V_NRCONTADOR + 1;
            END LOOP;
         END LOOP;

         INSERT INTO INT_ORDENTSAI
            (CODSTE, NROORD, NROORDEXT, CODPRIATD, CODPSSFLL,
             CODPSSPNTDST, CODPSSTRP, CODTIPMDLTRP, CODTIPORD, NUMAGP,
             DATATD, DESOBS, BOLATDPRC, BOLCANORDATDPRC, BOLMNTPLT,
             BOLPERINSITMORD, FLAPRC, CODPSSPRP, IDCSEQ, CODPSSCLI,
             BOLRECMERFORPED, DATGERORD, DSCERR, DATULTPRC, CODPSSFOR,
             GERAUTOPE, NROITM, DATAGN, CODAGPMTG, BOLCANLOT,
             NUMSEQCRG, NROEXT, BOLPERPENESQ)
         VALUES
            (C_NF.CDFILIALSAGA, C_NF.NROORD, NULL, 50, NULL,
             NULL, C_NF.NRINSJURNF, 2, C_NF.CODTIPORD, NULL,
             C_NF.DTMOVI, NULL, 1, 1, 1,
             1, 0, '5', C_NF.IDCSEQ, C_NF.NRINSJURNF,
             1, NULL, NULL, NULL, 0,
             0, 0, NULL, NULL, 0,
             0, NULL, 0);

         V_NRCONTADOR := V_NRCONTADOR + 1;
      END IF;

      INSERT INTO INT_ITMORDENTSAI
         (CODSTE, CODPSSPRP, NROORDEXT, NROORD, NROITMORD,
          NROITMORDEXT, CODMER, VALEMBSKU, CODDSP, CODMTVBLQ,
          CODSTSESQ, CODTIPRCB, VLRQTDMER, DATFABPRG, DATFIMPRG,
          DATLIMFAB, DATLIMINF, DATLIMSUP, DATVNCPRG, BOLDATLIMFLX,
          BOLREFDATFAB, BOLREQCAROPC, BOLMERCMP, BOLTRCEMB, FLAPRC,
          CODTIPORD, DSCERR, DATULTPRC)
      VALUES
         (C_NF.CDFILIALSAGA, '5', NULL, C_NF.NROORD, C_NF.NRSEQITPROD,
          NULL, C_NF.CDARVPROD, C_NF.VRFATOCONV, '201', NULL,
          NULL, 1, C_NF.QTITEMPROD, NULL, NULL,
          NULL, NULL, NULL, NULL, 1,
          1, 1, 0, 0, '0',
          C_NF.CODTIPORD, NULL, NULL);

      UPDATE ITEMPEDIDO
         SET DTEXPITPEDSAGA = SYSDATE
       WHERE CDFILIAL = C_NF.CDFILIAL
         AND NRPEDIDO = C_NF.NRLANCTONF
         AND NRITEMPED = C_NF.NRITEMPED;

      UPDATE PEDIDO
         SET DTEXPPEDSAGA = SYSDATE
       WHERE CDFILIAL = C_NF.CDFILIAL
         AND NRPEDIDO = C_NF.NRLANCTONF;

      V_NRCONTADOR := V_NRCONTADOR + 1;

      IF V_NRCONTADOR = 500 THEN
         V_NRCONTADOR := 0;
         COMMIT;
      END IF;

      V_CHAVENF := C_NF.NROORD;

   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_ORDEM_SAIDA_SAGA','5.45.XXX'); END;
/

